<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\AppOfflineService;
use FM\Traits\TResponse;

class AppOfflineController
{

    use TResponse;
    protected $AppOfflineService;

    public function __construct(AppOfflineService $AppOfflineService)
    {
        $this->AppOfflineService = $AppOfflineService;
    }

    public function getDadosTarefaOffline()
    {
       
        try {
            $data = $this->AppOfflineService->getDadosTarefaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEpisTarefaOffline()
    {
        try {
            $data = $this->AppOfflineService->getEpisTarefaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosTarefasOffline()
    {
       
        try {
            $data = $this->AppOfflineService->getFotosTarefasOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosAprovacaoOffline()
    {
       
        try {
            $data = $this->AppOfflineService->getFotosAprovacaoOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensTarefasOffline()
    {
        try {
            $data = $this->AppOfflineService->getItensTarefasOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOrdenacoes(Request $request)
    {
        try {
            $data = $this->AppOfflineService->getOrdenacoes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocalCliente(Request $request)
    {
        try {
            $data = $this->AppOfflineService->getLocalCliente();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getParametrizacaoGeral()
    {
        try {
            $data = $this->AppOfflineService->getParametrizacaoGeral();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getModeloPopOffline()
    {
        try {
            $data = $this->AppOfflineService->getModeloPopOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosOffline()
    {
        try {
            $data = $this->AppOfflineService->getCriteriosOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAtividadesOffline()
    {
        try {
            $data = $this->AppOfflineService->getAtividadesOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTopicosAuditoriaOffline()
    {
        try {
            $data = $this->AppOfflineService->getTopicosAuditoriaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosAuditoriaOffline()
    {
        try {
            $data = $this->AppOfflineService->getCriteriosAuditoriaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCategoriasAuditoriaOffline()
    {
        try {
            $data = $this->AppOfflineService->getCategoriasAuditoriaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAvaliacaoOffline()
    {
        try {
            $data = $this->AppOfflineService->getAvaliacaoOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosSolicitacaoOffline()
    {
        try {
            $data = $this->AppOfflineService->getFotosSolicitacaoOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImagensAuditoriaOffline()
    {
        try {
            $data = $this->AppOfflineService->getImagensAuditoriaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosVistoriasOffline()
    {
        try {
            $data = $this->AppOfflineService->getFotosVistoriasOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getParamOffline()
    {
        try {
            $data = $this->AppOfflineService->getParamOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
