<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SolicitacaoServService;
use FM\Traits\TResponse;

class SolicitacaoServController
{
    use TResponse; 
    protected $SolicitacaoServService;

    public function __construct(SolicitacaoServService $SolicitacaoServService)
    {
        $this->SolicitacaoServService = $SolicitacaoServService;
    }

    public function saveSolicitacaoServico(Request $request)
    {
        try {
            $parametros = $request->getParameters();
            $this->SolicitacaoServService->saveSolicitacaoServico($parametros);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSolicitacoesServDash()
    {

        try {
            $data = $this->SolicitacaoServService->getSolicitacoesServDash();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSolicitacoesAbertas(Request $request)
    {
        try {
            $data = $this->SolicitacaoServService->getSolicitacoesAbertas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSolicitacoeConvertidasOS(DTO\Request $request, DTO\Response $response)
    {

        try {
            $data = $this->SolicitacaoServService->getSolicitacoeConvertidasOS();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
